﻿using Syncfusion.XForms.DataForm;
using System;
using System.Collections.Generic;
using System.Text;

namespace dataform
{
    public class FormDto
    {
        [Display(Order = 0, Name = "First Name")]
        public string FirstName { get; set; }
        [Display(Order = 1, Name = "Last Name")]
        public string LastName { get; set; }
        [Display(Order = 3, Name = "Birthdate")]
        public DateTime? DateOfBirth { get; set; }

        [Display(AutoGenerateField = false)]
        public string Street { get; set; }
        [Display(AutoGenerateField = false)]
        public string Address2 { get; set; }
        [Display(AutoGenerateField = false)]
        public string City { get; set; }
        [Display(AutoGenerateField = false)]
        public string State { get; set; }
        [Display(AutoGenerateField = false)]
        public string PostalCode { get; set; }

        [Display(AutoGenerateField = false)]
        public string ContactPhoneNumber { get; set; }
        [Display(AutoGenerateField = false)]
        public string MobilePhoneNumber { get; set; }

        [Display(Order = 4, Name = "Email", Prompt = "user@domain.com")]
        public string EmailAddress { get; set; }
        [Display(Order = 5, Name = "Confirm", Prompt = "user@domain.com")]
        public string ConfirmEmailAddress { get; set; }
        [DataType(DataType.Password)]
        [Display(Order = 6, Name = "Password", Prompt = "min 6 characters")]
        public string Password { get; set; }
        [DataType(DataType.Password)]
        [Display(Order = 7, Name = "Confirm", Prompt = "min 6 characters")]
        public string ConfirmPassword { get; set; }

        [Display(AutoGenerateField = false)]
        public GenderType Gender { get; set; }
        [Display(Order = 2, Name = "Gender")]
        public string DisplayGender
        {
            get { return GetEnumKey(Gender); }
            set { Gender = GetEnumValue<GenderType>(value); }
        }
        [Display(AutoGenerateField = false)]
        public string TimeZone { get; set; }

        [Display(AutoGenerateField = false)]
        public double? Height { get; set; }

        [Display(AutoGenerateField = false)]
        public bool TermsAgreedTo { get; set; }

        [Display(AutoGenerateField = false)]
        public string UserToken { get; set; }

        T GetEnumValue<T>(string key)
        {
            if (key == null)
                return default(T);
            try
            {
                return (T)Enum.Parse(typeof(T), key, true);
            }
            catch
            {
                return default(T);
            }
        }
        string GetEnumKey<T>(T value)
        {
            if (value == null)
                return default(string);
            return Enum.GetName(typeof(T), value);
        }
    }

    public enum GenderType
    {
        Unknown = 0,
        Male,
        Female,
        Either,
    }

   
}
