﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace dataform
{
    public class NavPage : ContentPage
    {
        public NavPage()
        {
            NavigationPage.SetHasNavigationBar(this, false);
            this.SetBinding(IsBusyProperty, "IsBusy");
        }

        protected override async void OnAppearing()
        {
            base.OnAppearing();
            
            // Uncomment this line to see desired scrollinb behavior
            //await Navigation.PushAsync(new StartPage());


            var layout = new StackLayout
            {
                Margin = new Thickness(20, 40, 20, 20),
                HorizontalOptions = LayoutOptions.FillAndExpand,
                VerticalOptions = LayoutOptions.StartAndExpand,
                Spacing = 5,
            };

            var createAccountLabel = new Label
            {
                Text = "New user? Tap here to create account.",
                HorizontalTextAlignment = TextAlignment.End,
                VerticalTextAlignment = TextAlignment.Start,
            };
            var activateTap = new TapGestureRecognizer();
            activateTap.Tapped += async (s, e) =>
            {
                createAccountLabel.Opacity = .5;
                await Task.Delay(250);
                createAccountLabel.Opacity = 1;
                await CreateAccount(Navigation);
            };
            createAccountLabel.GestureRecognizers.Add(activateTap);
            layout.Children.Add(createAccountLabel);
            Content = layout;
        }

        public async Task CreateAccount(INavigation stack)
        {
            await Navigation.PushAsync(new StartPage());
        }
    }
}
